<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;

class Dfs51000InutilizacaoNotaFiscalEletronicaController extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $dataSourceName = '';
    protected $dataSourceNameToSave = '';
    protected $parameterBagColumns = array();
    protected $dfs51000inutilizacaonotafiscaleletronicaservice;

    public function __construct($crudService, $parameterBag,$dfs51000inutilizacaonotafiscaleletronicaservice) {
        parent::__construct($crudService, $parameterBag);
        $this->dfs51000inutilizacaonotafiscaleletronicaservice = $dfs51000inutilizacaonotafiscaleletronicaservice;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filtro = $request->getFilterCriteria();
            if(!empty ($filtro->getConditions()) ){
                $dataSet = $this->dfs51000inutilizacaonotafiscaleletronicaservice->findInutilizacao($filtro);
                $response->addDataSet($dataSet);
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function confirmarInutilizaoNf(DTO\Request $request, DTO\Response $response) {
        try {
            $config = $request->getDataSet()->getRows()[0]['config'];
            $rows = $request->getDataSet()->getRows()[0]['rows'];
            $this->dfs51000inutilizacaonotafiscaleletronicaservice->confirmarInutilizacao($config,$rows);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function confirmarAgendamentoNf(DTO\Request $request, DTO\Response $response) {
        try {
            $config = $request->getDataSet()->getRows()[0]['config'];
            $row = $request->getDataSet()->getRows()[0]['row'];
            $this->dfs51000inutilizacaonotafiscaleletronicaservice->gerarNovalConsulta($config,$row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function dadosAgendamento(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $data = $this->dfs51000inutilizacaonotafiscaleletronicaservice->buscarAgengamneto($request->getFilterCriteria());
            $response->addDataSet($data);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

}